<?php

namespace App\Http\Controllers\Users;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class AfibController extends Controller
{
    public function addUpdateAfib(Request $request)
    {
        if ($request->all()['etat_afib'] == 'nouveau') {

            DB::table('rh_afib')->insert([
                'AFIB_FKEMPLOYEEID' => $request->all()['user_id'],
                'AFIB_DEMANDEINSCRIPTION' => $request->all()['datedemande_afib'],
                'AFIB_VALIDATIONINSCRIPTION' => $request->all()['date_afib'],
                'AFIB_ETAT' => 'En cours',
                'AFIB_MONTANT' => str_replace(',', '.', $request->all()['montant_afib']),
                'AFIB_PAYEPAR' => $request->all()['payepar_afib'],
                'AFIB_DESCRIPTION' => $request->all()['description_afib'],
            ]);
        } else {

            $etat = 'En cours';

            if (
                $request->all()['datedemande_afib'] != null &&
                $request->all()['date_afib'] != null
            ) {
                $etat = 'OK';
            }

            DB::table('rh_afib')
                ->where('AFIB_ID', '=', $request->all()['afib_id'])
                ->update([
                    'AFIB_DEMANDEINSCRIPTION' => $request->all()['datedemande_afib'],
                    'AFIB_VALIDATIONINSCRIPTION' => $request->all()['date_afib'],
                    'AFIB_ETAT' => $etat,
                    'AFIB_MONTANT' => str_replace(',', '.', $request->all()['montant_afib']),
                    'AFIB_PAYEPAR' => $request->all()['payepar_afib'],
                    'AFIB_DESCRIPTION' => $request->all()['description_afib'],
                ]);
        }

        return back()->withInput();
    }
}
