<?php

namespace App\Http\Livewire\Devices;

use Livewire\Component;
use Illuminate\Support\Facades\DB;

class DevicesTableMod extends Component
{
    public function getInfoIccAllDevices()
    {
        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->get();
    }

    public function allActivesDevices()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_FKEMPLOYEEID', "!=", NULL)
            ->get();
    }

    public function allInactivesDevices()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_FKEMPLOYEEID', "=", NULL)
            ->get();
    }

    public function allDevicesToRenew()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_ENROLLEDDATETIME', "<", $date)
            ->get();
    }

    public function allExpiredDevices()
    {
        $date = now();
        $date =  strtotime("-9 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_ENROLLEDDATETIME', "<", $date)
            ->get();
    }

    public function countActivesDevices()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_FKEMPLOYEEID', "!=", NULL)
            ->count();
    }

    public function countInactivesDevices()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_FKEMPLOYEEID', "=", NULL)
            ->count();
    }

    public function countDevicesToRenew()
    {
        $date = now();
        $date =  strtotime("-6 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->where('DEVICE_ENROLLEDDATETIME', "<", $date)
            ->count();
    }

    public function countExpiredDevices()
    {
        $date = now();
        $date =  strtotime("-9 month", strtotime($date));
        $date = date('Y/m/d h:i:s', $date);

        return DB::table('rh_devices')
            ->where('DEVICE_ENROLLEDDATETIME', "<", $date)
            ->count();
    }

    public function allDevices()
    {
        return DB::table('rh_devices')
            ->join('rh_employees', 'rh_employees.EMPLOYEE_ID', '=', 'rh_devices.DEVICE_FKEMPLOYEEID')
            ->get();
    }

    public $tableLayout;
    public $tableTitleIcon;
    public $tableTitle;

    public function render()
    {
        return view($this->tableLayout, [
            'tableLayout' => $this->tableLayout,
            'tableTitleIcon' => $this->tableTitleIcon,
            'tableTitle' => $this->tableTitle,
            'allDevices' => $this->allDevices(),
            'allActivesDevices' => $this->allActivesDevices(),
            'allInactivesDevices' => $this->allInactivesDevices(),
            'allDevicesToRenew' => $this->allDevicesToRenew(),
            'allExpiredDevices' => $this->allExpiredDevices(),
            'countActivesDevices' => $this->countActivesDevices(),
            'countInactivesDevices' => $this->countInactivesDevices(),
            'countDevicesToRenew' => $this->countDevicesToRenew(),
            'countExpiredDevices' => $this->countExpiredDevices(),
        ]);
    }
}
