<?php

namespace App\Http\Livewire\Users;

use Livewire\Component;
use Illuminate\Support\Facades\DB;

class UsersTableMod extends Component
{
    public function getInfoIccAllHr()
    {

        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->get();
    }

    public function allActivesMembers()
    {

        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->get();
    }

    public function allInactivesMembers()
    {

        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '0')
            ->get();
    }

    public function allActivesAffiliates()
    {

        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_TYPE', '=', 'Filiale')
            ->where('rh_agences.AGENCE_NOM', '!=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->get();
    }

    public function allActivesFranchisees()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_TYPE', '=', 'Franchise')
            ->where('rh_agences.AGENCE_NOM', '!=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->get();
    }

    public function allActivesIccDev()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_NOM', '=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->get();
    }

    public function countActivesMembers()
    {
        return DB::table('rh_employees')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->count();
    }

    public function countInactivesMembers()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '0')
            ->count();
    }

    public function countActivesAffiliates()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_TYPE', '=', 'Filiale')
            ->where('rh_agences.AGENCE_NOM', '!=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->count();
    }

    public function countActivesFranchisees()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_TYPE', '=', 'Franchise')
            ->where('rh_agences.AGENCE_NOM', '!=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->count();
    }

    public function countActivesIccDev()
    {
        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->where('rh_agences.AGENCE_NOM', '=', 'ICC Développement')
            ->where('EMPLOYEE_COMPTEACTIF', '=', '1')
            ->count();
    }

    public function userInfo()
    {

        return DB::table('rh_employees')
            ->join('rh_agences', 'rh_agences.AGENCE_ID', '=', 'rh_employees.EMPLOYEE_FKAGENCEID')
            ->join('rh_orias', 'rh_employees.EMPLOYEE_ID', '=', 'rh_orias.ORIAS_FKEMPLOYEEID')
            ->join('rh_ieam', 'rh_employees.EMPLOYEE_ID', '=', 'rh_ieam.IEAM_FKEMPLOYEEID')
            ->join('rh_afib', 'rh_employees.EMPLOYEE_ID', '=', 'rh_afib.AFIB_FKEMPLOYEEID')
            ->get();
    }

    public $tableLayout;
    public $tableTitleIcon;
    public $tableTitle;

    public function render()
    {
        return view($this->tableLayout, [
            'tableLayout' => $this->tableLayout,
            'tableTitleIcon' => $this->tableTitleIcon,
            'tableTitle' => $this->tableTitle,
            'allUsers' => $this->getInfoIccAllHr(),
            'userInfo' => $this->userInfo(),
            'allActivesMembers' => $this->allActivesMembers(),
            'allInactivesMembers' => $this->allInactivesMembers(),
            'allActivesAffiliates' => $this->allActivesAffiliates(),
            'allActivesFranchisees' => $this->allActivesFranchisees(),
            'allActivesIccDev' => $this->allActivesIccDev(),
            'countActivesMembers' => $this->countActivesMembers(),
            'countInactivesMembers' => $this->countInactivesMembers(),
            'countActivesAffiliates' => $this->countActivesAffiliates(),
            'countActivesFranchisees' => $this->countActivesFranchisees(),
            'countActivesIccDev' => $this->countActivesIccDev(),
        ]);
    }
}
