<div class="mx-4">
    @if ($oriasInfoUpdate)
        @foreach ($oriasInfoUpdate as $orias)
            <form name="add_update_orias_form" id="add_update_orias_form" method="post"
                action="{{ route('add_update_orias') }}">
                @csrf
                <div class="mx-3">
                    <h1 class="text-xl font-bold capitalize text-white pb-4"><em
                            class="fa-solid fa-file-circle-question mr-2"></em>Informations dernière demande</h1>
                    <div class="card card-body border card-plain border-radius-lg">
                        <div class="row mb-2">
                            <input hidden="hidden" id="orias_id" name="orias_id" value="{{ $orias->ORIAS_ID }}" />
                            <input hidden="hidden" id="user_id" name="user_id"
                                value="{{ $orias->ORIAS_FKEMPLOYEEID }}" />
                            <div class="col-3">
                                <label for="etat_orias" class="form-label text-xs">Statut</label>
                                <select id="etat_orias" name="etat_orias" class="form-select px-3 bg-white"
                                    aria-label="actif ?">
                                    @if ($orias->ORIAS_ETAT == 'Nouveau')
                                        @php
                                            $selectedNouveau = 'selected';
                                            $selectedEncours = '';
                                            $selectedOk = '';
                                        @endphp
                                    @elseif ($orias->ORIAS_ETAT == 'En cours')
                                        @php
                                            $selectedNouveau = '';
                                            $selectedEncours = 'selected';
                                            $selectedOk = '';
                                        @endphp
                                    @elseif ($orias->ORIAS_ETAT == 'OK')
                                        @php
                                            $selectedNouveau = '';
                                            $selectedEncours = '';
                                            $selectedOk = 'selected';
                                        @endphp
                                    @else
                                        @php
                                            $selectedNouveau = 'selected';
                                            $selectedEncours = '';
                                            $selectedOk = '';
                                        @endphp
                                    @endif
                                    <option value='nouveau' {{ $selectedNouveau }}>Nouveau</option>
                                    <option value='en_cours' {{ $selectedEncours }}>En cours</option>
                                    <option value='ok' {{ $selectedOk }}>OK</option>
                                </select>
                            </div>
                            @php
                                $dateDemandeOrias = str_replace(' ', 'T', $orias->ORIAS_DEMANDEINSCRIPTION);
                                $dateOrias = str_replace(' ', 'T', $orias->ORIAS_VALIDATIONINSCRIPTION);
                                $montantOrias = number_format($orias->ORIAS_MONTANT, 2, ',', ' ');
                            @endphp
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'datetime-local',
                                'id' => 'datedemande_orias',
                                'label' => "Demande d'inscription",
                                'value' => $dateDemandeOrias,
                                'required' => '',
                            ])
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'datetime-local',
                                'id' => 'date_orias',
                                'label' => "Validation de l'inscription",
                                'value' => $dateOrias,
                                'required' => '',
                            ])
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'text',
                                'id' => 'montant_orias',
                                'label' => 'Montant',
                                'value' => $montantOrias,
                                'required' => '',
                            ])
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'text',
                                'id' => 'numero_orias',
                                'label' => 'Numéro',
                                'value' => $orias->ORIAS_NUMERO,
                                'required' => '',
                            ])
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'text',
                                'id' => 'payepar_orias',
                                'label' => 'Payé par',
                                'value' => $orias->ORIAS_PAYEPAR,
                                'required' => '',
                            ])
                            @include('components.form-items', [
                                'colsize' => '3',
                                'bgcolor' => 'bg-white',
                                'type' => 'text',
                                'id' => 'description_orias',
                                'label' => 'Description',
                                'value' => $orias->ORIAS_DESCRIPTION,
                                'required' => '',
                            ])
                            <div class="col-3 mt-1">
                                <label for="submit_orias" class="form-label text-xs"></label>
                                <button id="submit_orias" type="submit"
                                    class="btn bg-blue-700 bg-gradient-info text-white font-medium rounded-lg text-sm w-full px-5 py-2.5 text-center">
                                    Valider
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        @endforeach
    @endif

    <!-- Historique Orias -->
    <div class="mx-3 mt-4 pt-2 mb-4">
        <h1 class="text-xl font-bold capitalize text-white pb-4"><i
                class="fa-solid fa-house-chimney"></i>&nbsp;Historique</h1>
        <div class="card card-body border card-plain border-radius-lg">
            <div class="table-responsive mb-2">
                <table class="table align-items-center mb-0" aria-describedby="historique des demandes orias">
                    <thead>
                        <tr>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Inscription</th>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Validation</th>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Montant</th>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Numéro</th>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Payé par</th>
                            <th class="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">
                                Description</th>
                        </tr>
                    </thead>
                    <tbody>
                        @if ($this->oriasHistory())
                            @foreach ($this->oriasHistory() as $orias)
                                @php
                                    $dateDemandeOrias = date('d/m/Y', strtotime(str_replace(' ', 'T', $orias->ORIAS_DEMANDEINSCRIPTION)));
                                    $dateOrias = date('d/m/Y', strtotime(str_replace(' ', 'T', $orias->ORIAS_VALIDATIONINSCRIPTION)));
                                @endphp
                                <tr>
                                    @if (null === $orias->ORIAS_DEMANDEINSCRIPTION)
                                        <td class="px-6 py-4 text-center" colspan="6">
                                            <div class="p-4 text-sm font-bold bg-gradient-danger rounded-lg"
                                                role="alert">
                                                Aucun historique trouvé. Il s'agit peut-être d'un arrivant jamais
                                                inscrit à l'Orias ou n'étant pas un courtier.
                                            </div>
                                        </td>
                                    @else
                                        <td class="text-center">
                                            {{ $dateDemandeOrias }}
                                        </td>
                                        <td class="text-center">
                                            @if ($dateOrias)
                                                {{ $dateOrias }}
                                            @else
                                                -
                                            @endif
                                        </td>
                                        <td class="text-center">
                                            @if ($orias->ORIAS_MONTANT)
                                                @php echo number_format($orias->ORIAS_MONTANT, 2, ',', ' ') . ' €'; @endphp
                                            @else
                                                - €
                                            @endif
                                        </td>
                                        <td class="text-center">
                                            @if ($orias->ORIAS_NUMERO)
                                                {{ $orias->ORIAS_NUMERO }}
                                            @else
                                                -
                                            @endif
                                        </td>
                                        <td class="text-center">
                                            @if ($orias->ORIAS_PAYEPAR)
                                                {{ $orias->ORIAS_PAYEPAR }}
                                            @else
                                                -
                                            @endif
                                        </td>
                                        <td class="text-center">
                                            @if ($orias->ORIAS_DESCRIPTION)
                                                {{ $orias->ORIAS_DESCRIPTION }}
                                            @else
                                                -
                                            @endif
                                        </td>
                                    @endif
                                </tr>
                            @endforeach
                        @endif
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
